package com.bureau.base.mvibase

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.compose.runtime.Composable
import androidx.compose.ui.platform.ComposeView
import androidx.compose.ui.platform.ViewCompositionStrategy
import androidx.fragment.app.Fragment
import app.zophop.mvibase.simple.ChaloBaseSimpleMviViewModel
import com.bureaumonorepo.ui.theme.MonoRepoTheme

abstract class ChaloBaseSimpleMviComposeFragment<ViewIntent, ViewSate, ViewSideEffect,
    ViewModel : ChaloBaseSimpleMviViewModel<ViewIntent, ViewSate, ViewSideEffect>> : Fragment() {

    abstract val viewModel: ViewModel

    @Composable
    abstract fun MainScreen()

    open fun saveViewStateToSavedStateHandle(viewState: ViewSate) {}

    /*@Inject

    @Inject
    lateinit var navigationContract: NavigationContract*/

    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View? {
        return context?.let {
            ComposeView(it).apply {
                setViewCompositionStrategy(ViewCompositionStrategy.DisposeOnViewTreeLifecycleDestroyed)
                setContent {
                    MonoRepoTheme {
                        MainScreen()
                    }
                }
            }
        }
    }
}
